"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NerdAppBarMenuItem = exports.NerdAppBar = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const material_1 = require("@mui/material");
const system_1 = require("@mui/system");
const React = __importStar(require("react"));
const react_router_dom_1 = require("react-router-dom");
/**
 * @component
 * @param {string} title title of the app
 * @param {string} logo Logo of the app
 * @param {string} variant Size of the appBar (dense or regular)
 * @param {Array<NerdAppBarContent | JSX.Element>} content Height of the appbar. Could be dense or regular.
 * @returns {JsxElement} UserDisplay component
 */
function NerdAppBar({ title, logo, content = [], variant = "regular", }) {
    return ((0, jsx_runtime_1.jsxs)(material_1.AppBar, Object.assign({ position: "fixed", sx: {
            zIndex: (theme) => theme.zIndex.drawer + 1,
            background: (theme) => theme.palette.background.default,
        }, elevation: 0, color: "transparent" }, { children: [(0, jsx_runtime_1.jsxs)(material_1.Toolbar, Object.assign({ variant: variant }, { children: [(0, jsx_runtime_1.jsxs)(material_1.Button, Object.assign({ href: "/", sx: { color: "text.primary" } }, { children: [(0, jsx_runtime_1.jsx)("img", { alt: "logo", src: logo, height: variant === "dense" ? "30px" : "45px" }, void 0), (0, jsx_runtime_1.jsx)(material_1.Hidden, Object.assign({ smDown: true }, { children: title }), void 0)] }), void 0), (0, jsx_runtime_1.jsx)(material_1.Divider, { sx: { m: 1 }, orientation: "vertical", flexItem: true }, void 0), content.map((c) => {
                        if (isNerdAppBarContent(c))
                            return (0, jsx_runtime_1.jsx)(NerdAppBarMenuItem, Object.assign({}, c), void 0);
                        return c;
                    })] }), void 0), (0, jsx_runtime_1.jsx)(material_1.Divider, {}, void 0)] }), void 0));
}
exports.NerdAppBar = NerdAppBar;
/**
 *
 * @param toTest element you want to know if it has the NerdAppBarContent type
 * @returns {boolean}
 */
function isNerdAppBarContent(toTest) {
    return toTest.title !== undefined;
}
/**
 * @param {NerdAppBarContent} c Content of the menu item
 * @returns {JSX.Element} the menu
 **/
function NerdAppBarMenuItem(c) {
    const theme = (0, system_1.useTheme)();
    const md = (0, material_1.useMediaQuery)(theme.breakpoints.up("md"));
    const [anchorEl, setAnchorEl] = React.useState(null);
    const open = Boolean(anchorEl);
    const handleClick = (event) => {
        setAnchorEl(event.currentTarget);
    };
    const handleClose = () => {
        setAnchorEl(null);
    };
    let buttonProps = {
        onClick: c.nested ? handleClick : c.callback,
    };
    if (c.href) {
        buttonProps = {
            component: react_router_dom_1.Link,
            to: c.href,
        };
    }
    return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [c.divider ? ((0, jsx_runtime_1.jsx)(material_1.Divider, { sx: { m: 1 }, orientation: "vertical", flexItem: true }, void 0)) : ([]), md ? ((0, jsx_runtime_1.jsx)(material_1.Button, Object.assign({}, c, buttonProps, { children: c.title }), void 0)) : ((0, jsx_runtime_1.jsx)(material_1.Tooltip, Object.assign({ title: `${c.title}` }, { children: (0, jsx_runtime_1.jsx)(material_1.IconButton, Object.assign({}, c, { color: "primary", size: "small" }, buttonProps, { children: c.startIcon }), void 0) }), void 0)), c.nested ? ((0, jsx_runtime_1.jsx)(StyledMenu, Object.assign({ id: "basic-menu", anchorEl: anchorEl, open: open, onClose: handleClose, anchorOrigin: {
                    vertical: "bottom",
                    horizontal: "right",
                }, transformOrigin: {
                    vertical: "top",
                    horizontal: "center",
                }, MenuListProps: {
                    "aria-labelledby": "basic-button",
                } }, { children: c.nested.map((n) => {
                    let buttonProps = {};
                    if (c.href) {
                        buttonProps = {
                            component: react_router_dom_1.Link,
                            to: c.href,
                        };
                    }
                    return ((0, jsx_runtime_1.jsxs)(material_1.ListItemButton, Object.assign({ dense: true, divider: n.divider }, buttonProps, { children: [typeof n.icon === "string" ? ((0, jsx_runtime_1.jsx)("div", Object.assign({ className: "faicon" }, { children: (0, jsx_runtime_1.jsx)("i", { className: n.icon }, void 0) }), void 0)) : ((0, jsx_runtime_1.jsx)(material_1.ListItemIcon, { children: n.icon }, void 0)), (0, jsx_runtime_1.jsx)(material_1.ListItemText, { primary: n.title, secondary: n.subtitle }, void 0)] }), void 0));
                }) }), void 0)) : ([])] }, void 0));
}
exports.NerdAppBarMenuItem = NerdAppBarMenuItem;
const StyledMenu = (0, system_1.styled)((props) => ((0, jsx_runtime_1.jsx)(material_1.Menu, Object.assign({ elevation: 0, anchorOrigin: {
        vertical: "bottom",
        horizontal: "right",
    }, transformOrigin: {
        vertical: "top",
        horizontal: "right",
    } }, props), void 0)))(({ theme }) => ({
    "& .MuiPaper-root": {
        borderRadius: 6,
        marginTop: 10,
        background: theme.palette.mode === "light" ? "white" : theme.palette.grey[900],
        minWidth: 180,
        color: theme.palette.mode === "light"
            ? "rgb(55, 65, 81)"
            : theme.palette.grey[300],
        boxShadow: "rgb(255, 255, 255) 0px 0px 0px 0px, rgba(0, 0, 0, 0.05) 0px 0px 0px 1px, rgba(0, 0, 0, 0.1) 0px 10px 15px -3px, rgba(0, 0, 0, 0.05) 0px 4px 6px -2px",
        "& .MuiMenu-list": {
            padding: "4px 0",
        },
        "& .MuiMenuItem-root": {
            "& .MuiSvgIcon-root": {
                fontSize: 18,
                color: theme.palette.text.secondary,
                marginRight: theme.spacing(1.5),
            },
            "&:active": {
                backgroundColor: (0, system_1.alpha)(theme.palette.primary.main, theme.palette.action.selectedOpacity),
            },
        },
    },
}));
